#include <bits/stdc++.h>
using namespace std;
#define int long long

vector<int> a;
int n, q;

int get(int x){
    int cnt = 0;
    vector<int> used(n, 0);
    for(int i = 0; i < n; i++){
        if(used[i]){
            continue;
        }
        cnt++;
        if(i == x){
            return cnt;
        }
        if(a[i] == a[i + 1]){
            int nxt = i + 1;
            for(int j = i + 2; j < n; j++){
                if(used[j] == 0 && a[j] != a[i]){
                    nxt = j;
                    break;
                }
            }
            cnt++;
            while(used[nxt]){
                nxt++;
            }
            used[nxt] = 1;
            if(x == nxt){
                return cnt;
            }
        }
    }
}

signed main(){
    cin >> n >> q;
    a.resize(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    while(q--){
        int op;
        cin >> op;
        if(op == 1){
            int x;
            cin >> x;
            x--;
            swap(a[x], a[x + 1]);
        }else{
            int x;
            cin >> x;
            x--;
            cout << get(x) << endl;
        }
    }
}
